<?php
// Recommend
// Simple 'tell-a-friend-about-this-page' script
//
// Revisions:
// 1.0.0 - 2003-01-02 - Morten Wulff <wulff@ratatosk.net>
// 1.1.0 - 2003-05-27 - Morten Wulff <wulff@ratatosk.net>
//         Added usage log

$base_url = 'http://www.domain.com';
$log_file = 'recommend.log';

/* --- mail message --------------------------------------------------------- */

$mail_subject = '%mail_from% wants you to check out MySite';

$mail_body = <<<BODY
Hi %mail_name%,

Your friend %mail_from% wants you to see the following
page on MySite:

%page_url%

Kind regards,

The Management
BODY;

/* --- error messages ------------------------------------------------------- */

$error_empty = <<<HTML
<h1>Missing Fields</h1>
<p>
    You haven't filled out all the required form fields. Use your browser's
    'back' button to return to the form.
</p>
HTML;

$error_mail = <<<HTML
<h1>Cannot Deliver Mail</h1>
<p>
    Your message to %mail_to% can not be delivered. Please make sure you
    have entered the correct e-mail address.
</p>
HTML;

$error_referer = <<<HTML
<h1>Unknown Referrer</h1>
<p>
    This script can only be called from $base_url.
</p>
HTML;

/* --- success messages ----------------------------------------------------- */

$success_mail = <<<HTML
<h1>Mail Delivered</h1>
<p>
    Your message to %mail_to% has been delivered.
</p>
<p>
    You can either <a href="javascript:history.go(-1);">return to the previous page</a> or
    <a href="/">go to the front page</a>.
</p>
HTML;

/* --- don't change anything below this line -------------------------------- */

require('header.inc');

if ( eregi("^$base_url", $HTTP_REFERER) ) {
    if ($mail_from == '' || $mail_reply == '' || $mail_name == '' || $mail_to == '') {
        // empty form
        echo $error_empty;
    } else {
        // insert name and url in mail body
        $search  = array (
            "/%mail_from%/",
            "/%mail_name%/",
            "/%page_url%/",
        );
        $replace = array (
            $mail_from,
            $mail_name,
            $HTTP_REFERER
        );
        $mail_body    = preg_replace ($search, $replace, $mail_body);
        $mail_subject = preg_replace ("/%mail_from%/", $mail_from, $mail_subject);

        // send mail
        $sent = mail ($mail_to, $mail_subject, $mail_body, "From: $mail_reply\r\n");

        if ($sent) {
            $success_mail = preg_replace ("/%mail_to%/", "$mail_to", $success_mail);
            echo $success_mail;
        } else {
            $error_mail = preg_replace ("/%mail_to%/", "$mail_to", $error_mail);
            echo $error_mail;
        }
    }

    // write info to log file
    $log_line = time() . "\t$mail_from\t$mail_reply\t$mail_name\t$mail_to\t$HTTP_REFERER\n";

    if ( !($fp = fopen($log_file, "a")) ) die ("Cannot open log file '$log_file'.");
    fwrite ($fp, $log_line);
    fclose ($fp);
} else {
    // invalid referer -- print error
    echo $error_referer;
}

require('footer.inc');

?>
